var CreateHTML = {
	HTML_SOURCE: CommonFunc.loadText("chrome://sagepp/content/res/template-html.txt"),
	ITEM_SOURCE: CommonFunc.loadText("chrome://sagepp/content/res/template-item.txt"),
	DEFAULT_CSS: [ // Modified by Higmmer
		"chrome://sagepp/content/res/sagepp_default.css",
		"chrome://sagepp/content/res/sagepp_single.css"
	],

	_tabbed: false,
	set tabbed(aValue){ this._tabbed = aValue },
	
	// Added by Higmmer
	_focusNewTab: false,
	set focusNewTab(aValue){ this._focusNewTab = aValue },

	openHTML: function(feed) {
		if(!feed) return;

		try {
			var htmlURL = this.createHTML(feed);
			//----- Modified by Higmmer : Start ----->
			var browser = getContentBrowser();
			if(this._tabbed && !isTabEmpty(browser.selectedTab)) {
				var newtab;
				if(browser.TMmoveTabTo) { // Tweak for Tab Mix Plus
					var nexttab = browser.mTabContainer.nextTab;
					newtab = browser.addTab(htmlURL);
					if(auto_update_mode) {
						var newpos = browser.browsers.length - 1
						if(newtab._tPos < newpos) browser.TMmoveTabTo(newtab, newpos, 1);
						browser.mTabContainer.nextTab = nexttab;
					}
				} else {
					newtab = browser.addTab(htmlURL);
				}
				if(this._focusNewTab) browser.selectedTab = newtab;
			} else {
				browser.loadURI(htmlURL);
				browser.contentWindow.focus();
			}
			//<----- Modified by Higmmer : End -----
		} catch(e) {}
	},

	createHTML: function(feed) {
		//----- Modified by Higmmer : Start ----->
		var tmpFile = this.getOutputFile(feed);

		var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
						.createInstance(Components.interfaces.nsIFileOutputStream);
		stream.init(tmpFile, 2, 0x200, false); // open as "write only"
		
		var content = this.createHTMLSource(feed);
		stream.write(content, content.length);
		stream.flush();
		stream.close();

		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService);
		var xmlFilePath = ioService.newFileURI(tmpFile).spec;
		//<----- Modified by Higmmer : End -----

		return xmlFilePath;
	},

	getUserCssURL: function() {
		//----- Modified by Higmmer : Start ----->
		//var userCssEnable = CommonFunc.getPrefValue(CommonFunc.USER_CSS_ENABLE, "bool", false);
		var userCssSelect = CommonFunc.getPrefValue(CommonFunc.USER_CSS_SELECT, "int", 0);
		var userCssPath = CommonFunc.getPrefValue(CommonFunc.USER_CSS_PATH, "wstr", "");
		//if(!userCssEnable || !userCssPath) return null;
		if(userCssSelect != 2 || !userCssPath) return this.DEFAULT_CSS[userCssSelect];
		//<----- Modified by Higmmer : End -----

		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService);
		var tmpFile = Components.classes['@mozilla.org/file/local;1']
							.createInstance(Components.interfaces.nsILocalFile);
		try {		
			tmpFile.initWithPath(userCssPath);
			var cssUrl = ioService.newFileURI(tmpFile);
			var contentType = ioService.newChannelFromURI(cssUrl).contentType;
			//if(contentType != "text/css") return null; // Removed by Higmmer

			return cssUrl.spec;
		} catch(e) {
			return null;
		}
	},

	//----- Added by Higmmer : Start ----->
	getUserScriptURL: function() {
		var userScriptEnable = CommonFunc.getPrefValue(CommonFunc.USER_SCRIPT_ENABLE, "bool", false);
		var userScriptPath = CommonFunc.getPrefValue(CommonFunc.USER_SCRIPT_PATH, "wstr", "");
		if(!userScriptEnable || !userScriptPath) return null;

		var ioService = Components.classes["@mozilla.org/network/io-service;1"]
							.getService(Components.interfaces.nsIIOService);
		var tmpFile = Components.classes['@mozilla.org/file/local;1']
							.createInstance(Components.interfaces.nsILocalFile);
		try {		
			tmpFile.initWithPath(userScriptPath);
			var scriptUrl = ioService.newFileURI(tmpFile);
			var contentType = ioService.newChannelFromURI(scriptUrl).contentType;
			//if(!contentType.match(/javascript$|js$/i)) return null;

			return scriptUrl.spec;
		} catch(e) {
			return null;
		}
	},
	//<----- Added by Higmmer : End -----

	createHTMLSource: function(feed) {
		var allowEContent = CommonFunc.getPrefValue(CommonFunc.ALLOW_ENCODED_CONTENT, "bool", true);
		var twelveHourClock = CommonFunc.getPrefValue(CommonFunc.TWELVE_HOUR_CLOCK, "bool", false);
		var feedItemOrder = CommonFunc.getPrefValue(CommonFunc.FEED_ITEM_ORDER, "str", "chrono");

		var htmlSource = this.HTML_SOURCE;
		var cssUrl	= this.getUserCssURL();
		if(cssUrl) {
			htmlSource = htmlSource.replace("<TEMP_CSSURL/>", cssUrl); // Modified by Higmmer
		} else {
			htmlSource = htmlSource.replace("<TEMP_CSSURL/>", this.DEFAULT_CSS[0]); // Modified by Higmmer
		}
		//----- Added by Higmmer : Start ----->
		var scriptUrl = this.getUserScriptURL();
		if(scriptUrl) {
			htmlSource = htmlSource.replace("<TEMP_USERSCRIPT/>", 
				"<script type=\"application/javascript;version=1.8\" src=\"" + scriptUrl +"\"></script>");
		} else {
			htmlSource = htmlSource.replace("<TEMP_USERSCRIPT/>",
				"<script type=\"application/javascript\">function load(){} function unload(){}</script>");
		}
		var htmlFilterMethod = CommonFunc.getPrefValue(CommonFunc.HTML_FILTER_METHOD, "int", 1);
		var enclosureIconize = CommonFunc.getPrefValue(CommonFunc.ENCLOSURE_ICONIZE, "bool", true); // (inspired by Sage-Too)
		//<----- Added by Higmmer : End -----
		//----- Modified by Higmmer : Start ----->
		htmlSource = htmlSource.replace("<TEMP_HTMLTITLE/>", encodeAngleBrackets(feed.getTitle()))
		                       .replace("<TEMP_TITLE/>", encodeAngleBrackets(feed.getTitle()))
		                       .replace("<TEMP_LINK/>", encodeDoubleQuotations(encodeAngleBrackets(feed.getLink())), "g")
		                       .replace("<TEMP_DESCRIPTION/>", encodeAngleBrackets(feed.getDescription()))
		                       .replace("<TEMP_FEEDURL/>", encodeDoubleQuotations(encodeAngleBrackets(feed.getPath())));
		//<----- Modified by Higmmer : End -----

		var itemsSource = "";
		var items = feed.getItems(feedItemOrder);
		for(var i = 0; i < items.length; i++) {
			var link = encodeDoubleQuotations(encodeAngleBrackets(items[i].getLink())); // Modified by Higmmer
			var title = encodeAngleBrackets(items[i].getTitle()); // Modified by Higmmer
			var description = "";
			var pubDate = "";
			//----- Added by Higmmer : Start ----->
			var author = "";
			var category = "";
			var enclosure = "";
			var enclosure_icon = "";
			var noreflink = this.applySbmUrlFilter(items[i].getLink());
			var itemid = "item-" + (i+1);
			//<----- Added by Higmmer : End -----

			if(items[i].hasContent()) {
				//----- Modified by Higmmer : Start ----->
				if(htmlFilterMethod != 0) { // Higmmer customized method
					if(allowEContent) {
						description = htmlFilter(items[i].getContent(), items[i].getBaseURI());
					} else {
						description = encodeAngleBrackets(htmlToText(items[i].getContent()));
					}
				} else { // Sage 1.3.x original method
					if(allowEContent) {
						description = items[i].getContent();
					} else {
						description = encodeAngleBrackets(htmlToText(items[i].getContent()));
					}
					this.filterHtmlHandler.clear();
					this.simpleHtmlParser.parse(description);
					description = this.filterHtmlHandler.toString();
				}
				description = "<div id=\"" + itemid + "-desc\" class=\"item-desc\">" + description + "</div>";
				//<----- Modified by Higmmer : End -----
			}

			//----- Added by Higmmer : Start ----->
			if(items[i].hasCategory()) {
				category = "<div id=\"" + itemid + "-category\" class=\"item-category\">" + encodeAngleBrackets(items[i].getCategory()) + "</div>";
			}

			if(items[i].hasAuthor()) {
				author = "<div id=\"" + itemid + "-author\" class=\"item-author\">" + encodeAngleBrackets(items[i].getAuthor()) + "</div>";
			}

			if(items[i].hasPubDate()) {
				pubDate = "<div id=\"" + itemid + "-pubDate\" class=\"item-pubDate\">" + encodeAngleBrackets(dateFormat(items[i].getPubDate(), twelveHourClock)) + "</div>";
			}

			if(items[i].hasEnclosure()) {
				// JeffT's modification + Higmmer's tweak (inspired by Sage-Too)
				var enc = items[i].getEnclosure();
				var encUrl = encodeDoubleQuotations(encodeAngleBrackets(enc.getURL()));
				var encTitle = encUrl;
				var encLength = (enc.getLength() > 0) ? " (" + Math.round((enc.getLength() / 1048576) * 100) / 100 + " MB)" : "";
				var encType = (enc.getType() != "") ? " [" + encodeDoubleQuotations(encodeAngleBrackets(enc.getType())) + "]" : "";

				if(!enclosureIconize) {
					enclosure = "<div class=\"item-enclosure\">"
					          + "<a id=\"" + itemid + "-enclosure\" href=\"" + encUrl + "\" title=\"" + encTitle + encLength + encType + "\">"
					          + "<span class=\"item-enclosure-title\">" + encTitle + "</span></a>";
					if(encLength != "") {
						enclosure += "<span class=\"item-enclosure-length\">" + encLength + "</span>";
					}
					if(encType != "") {
						enclosure += "<span class=\"item-enclosure-type\">" + encType + "</span>";
					}
					enclosure += "</div>";
				} else {
					enclosure_icon = "<a id=\"" + itemid + "-enclosure\" href=\"" + encUrl + "\" title=\"" + encTitle + encLength + encType + "\">"
					               + "<span class=\"item-enclosure-icon\"><img src=\"chrome://sagepp/skin/icon/enclosure-play.png\" alt=\"" + encTitle + encLength + encType + "\" border=\"0\"></span>"
					               + "</a>";
				}
			}
			//<----- Added by Higmmer : End -----

			//----- Modified by Higmmer : Start ----->
			var itemSource = this.ITEM_SOURCE;
			itemSource = itemSource.replace("<TEMP_NUMBER/>", i+1)
			                       .replace("<TEMP_LINK/>", link)
			                       .replace("<TEMP_TITLE/>", title)
			                       .replace("<TEMP_DESCRIPTION/>", description)
			                       .replace("<TEMP_PUBDATE/>", pubDate)
			                       .replace("<TEMP_AUTHOR/>", author)
			                       .replace("<TEMP_CATEGORY/>", category)
			                       .replace("<TEMP_ENCLOSURE/>", enclosure)
			                       .replace("<TEMP_ENCLOSUREICON/>", enclosure_icon)
			                       .replace("<TEMP_HATEBU/>", escape(noreflink))
			                       .replace("<TEMP_SBMLINK/>", this.getSbmAddUrl(title, noreflink))
			                       .replace("<TEMP_ITEMID/>", itemid)
			                       .replace("<TEMP_ITEMTITLEID/>", itemid + "-title")
			                       .replace("<TEMP_ITEMORDINALID/>", itemid + "-ordinal")
			                       .replace("<TEMP_ITEMLINKID/>", itemid + "-link")
			                       .replace("<TEMP_SBMID/>", itemid + "-sbm");
			//<----- Modified by Higmmer : End -----
			itemsSource += itemSource;
		}
		htmlSource = htmlSource.replace("<TEMP_ITEMS/>", itemsSource);

		return CommonFunc.convertCharCodeFrom(htmlSource, "UTF-8");
	},

	//----- Added by Higmmer : Start ----->
	getSbmAddUrlDefault: function() {
		return "http://bookmarks.yahoo.co.jp/bookmarklet/showpopup?t=$TITLE$&u=$URL$&opener=sagepp&ei=UTF-8";
	},
	getSbmAddUrl: function(aTitle, aURL) {
		var sbmurl = this.getSbmAddUrlDefault();
		try {
			var tmp = CommonFunc.getPrefValue(CommonFunc.SBM_ADD_URL, "str", sbmurl);
			if(/^https?:/.test(tmp)) sbmurl = tmp;
		} catch(e) {
		}

		return encodeDoubleQuotations(encodeAngleBrackets(
		         sbmurl.replace(/\$TITLE\$/g, encodeURIComponent(aTitle))
		               .replace(/\$TITLE2\$/g, escape(aTitle))
		               .replace(/\$URL\$/g, encodeURIComponent(aURL))
		               .replace(/\$URL2\$/g, escape(aURL))
	           ));
	},
	getSbmUrlFilterDefault: function() {
		return "(ref|fr(om)?|in)=[a-z0-9%_-]+|(rss|xml|rdf|atom)";
	},
	getSbmUrlFilter: function() {
		var filter = this.getSbmUrlFilterDefault();
		var re = null;
		try {
			filter = CommonFunc.getPrefValue(CommonFunc.SBM_URL_FILTER, "str", filter);
		} catch(e) {
		}
		try {
			if(filter) re = new RegExp("^(" + filter + ")$", "i");
		} catch(e) {
		}
		return re;
	},
	applySbmUrlFilter: function(aUrl) {
		var filter = this.getSbmUrlFilter();
		var qx = aUrl.indexOf("?");
		if(!filter || qx == -1) return aUrl;

		var ubody = aUrl.substring(0, qx);
		var query = aUrl.substring(qx + 1).split("&");
		var result = new Array();
		for each(var param in query) {
			if(!filter.test(param)) result.push(param);
		}
		if(result.length > 0) ubody += "?" + result.join("&");
		return ubody;
	},
	getOutputFile: function(aFeed) { // inspired by Sage-Too
		var tmpFile = this.getOutputDir();

		if(!tmpFile.exists() || !tmpFile.isDirectory())
			tmpFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);

		if(CommonFunc.getPrefValue(CommonFunc.RENDER_FEEDS_TO_CACHE, "bool", false)) {
			var encodedUrl = hex_sha1(aFeed.getPath());
			tmpFile.appendRelativePath(encodedUrl + ".sagepp.html");
		} else {
			tmpFile.appendRelativePath("sagepp.html");
		}

		if(tmpFile.exists()) tmpFile.remove(true);
		tmpFile.create(tmpFile.NORMAL_FILE_TYPE, 0644);

		return tmpFile;
	},
	getOutputDir: function() {
		var tmpDir = this.getSpecialDir("UChrm");
		tmpDir.append("sagepp");
		return tmpDir;
	},
	//<----- Added by Higmmer : End -----

	getSpecialDir: function(aProp) {
		var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
		return dirService.get(aProp, Components.interfaces.nsILocalFile);
	},

	//----- Modified by Higmmer : Start (for delay-load) ----->
	_simpleHtmlParser: null, _filterHtmlHandler: null,
	get simpleHtmlParser() {
		if(!this._simpleHtmlParser) {
			this._simpleHtmlParser = new SimpleHtmlParser;
			this._simpleHtmlParser.contentHandler = this.filterHtmlHandler;
		}
		return this._simpleHtmlParser;
	},
	get filterHtmlHandler() {
		return this._filterHtmlHandler || (this._filterHtmlHandler = new FilterHtmlHandler);
	}
	//<----- Modified by Higmmer : End -----
}

//CreateHTML.simpleHtmlParser.contentHandler = CreateHTML.filterHtmlHandler; // Removed by Higmmer